<?php
/**
 * fmalertcookies.php
 *
 * php version 5
 *
 * @category  Joomla
 * @package   Joomla
 * @author    Folcomedia <contact@folcomedia.fr>
 * @copyright 2014 Folcomedia
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link      http://www.folcomedia.fr
 */

defined('_JEXEC') or die('Restricted access');

/**
 * Plugin Système Folcomedia Alert Cookies
 *
 * @category Joomla
 * @package  Joomla
 * @author   Folcomedia <contact@folcomedia.fr>
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link     http://www.folcomedia.fr
 */
class plgSystemFmAlertCookies extends JPlugin
{

	function onAfterInitialise(){
	
		$app      = JFactory::getApplication();		
					
		if ($app->isSite()) {		
			//insert les scripts nécessaire au bon fonctionnement du plugin	
			$document = JFactory::getDocument();
			
			//Gestion des scripts suivant la version de Joomla utilisée.       
	        if (JVERSION < 3) {
				$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/jquery-1.11.1.min.js');	
				$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/bootstrap.min.js');
				$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/bootstrap-responsive.min.css');
				$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/bootstrap.min.css');
	        } else {
					JHtml::_('jquery.framework');        	
			}

			$document->addScript(JURI::root().'plugins/system/fmalertcookies/assets/js/jquery.magnific-popup.min.js');
			$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/magnific-popup.css');		
			$document->addStyleSheet(JURI::root().'plugins/system/fmalertcookies/assets/css/folcomedia.css');
		}	
    }

	function onAfterRender()
    {
		if (!isset($_COOKIE['fmalertcookies'])) {

			$app      = JFactory::getApplication();			
			$link_readmore_menu = $this->params->get('link_readmore_menu');		
			//Test si l'on se trouve bien sur le site et non en administration
	        if (!$app->isSite() || strtolower($_SERVER['REQUEST_URI']) == strtolower(JRoute::_("index.php?Itemid=".$link_readmore_menu))) {
	            return;
	        }
			
			// Récupération des paramêtres	      
	        $position = $this->params->get('position');
			$type_affichage = $this->params->get('type_affichage');
	        $taille_cadre = $this->params->get('taille_cadre');
	        $texte = $this->params->get('texte_alert_cookies');
			$texte_couleur = $this->params->get('couleur_texte');
			$fond_couleur = $this->params->get('couleur_fond');			
			//Bordures
			$type_bordure = $this->params->get('type_bordure');
			$taille_bordure = $this->params->get('taille_bordure');
			$couleur_bordure = $this->params->get('couleur_bordure');			
			//Params btn more	
			$texte_readmore = $this->params->get('texte_readmore');
			$btn_more = $this->params->get('btn_more');			
			$position_btn_more = $this->params->get('position_btn_more');
			$taille_btn_more = $this->params->get('taille_btn_more');
			$couleur_btn_more = $this->params->get('couleur_btn_more');
			$couleur_texte_btn_more = $this->params->get('couleur_texte_btn_more');			
			//Params btn close
			$texte_close = $this->params->get('texte_close');
			$btn_close = $this->params->get('btn_close');
			$position_btn_close = $this->params->get('position_btn_close');
			$taille_btn_close = $this->params->get('taille_btn_close');
			$couleur_btn_close = $this->params->get('couleur_btn_close');
			$couleur_texte_btn_close = $this->params->get('couleur_texte_btn_close');		
			
			$application = JFactory::getApplication();
			$menu = $application->getMenu();
			$item = $menu->getItem($link_readmore_menu);
			
			switch ($type_bordure) {
				//Bordure arrondie	
				case '0':
					$css_bordure = "border:".$taille_bordure."px solid ".$couleur_bordure."; border-radius:5px";
					break;
				//Sans bordure
				case '2':
					$css_bordure = "";
					break;
				//Autres
				default:
					$css_bordure = "border: 1px solid ".$couleur_bordure.";";
					break;
			}
			
			//Teste si les deux ou un seul boutons est affichés
			$span= "span6";
			if (($btn_more && !$btn_close) || (!$btn_more && $btn_close)) {
				$span= "span12";	
			}

			$text_out ='<div id="cadre_alert_cookies" style="margin: 5px;">';
			$text_out .='<div style="margin:auto;max-width:'.$taille_cadre.'px;background-color: '.$fond_couleur.';'.$css_bordure.'">';
			$text_out .='<div style="padding:10px;color: '.$texte_couleur.'">'.$texte;
			$text_out .='<div class="row-fluid">';
			if ($btn_more) {
				if ($type_affichage == 1) {
					$text_out .='<div class="'.$span.' btn_readmore" style="text-align:'.$position_btn_more.'"><a style="color:'.$couleur_texte_btn_more.'" class="btn '.$couleur_btn_more.' '.$taille_btn_more.' read_more" href="'.JRoute::_("index.php?Itemid=".$link_readmore_menu).'">'.$texte_readmore.'</a></div>';					
				} elseif($type_affichage == 0) {						
					$text_out .='<div class="'.$span.' btn_readmore" style="text-align:'.$position_btn_more.'"><a style="color:'.$couleur_texte_btn_more.'" class="btn '.$couleur_btn_more.' '.$taille_btn_more.' read_more" onclick="jQuery.magnificPopup.close();" href="'.JRoute::_("index.php?Itemid=".$link_readmore_menu).'">'.$texte_readmore.'</a></div>';					
				}										
			}	
			if ($btn_close) {		
				$text_out .='<div class="'.$span.' btn_close" style="text-align:'.$position_btn_close.'"><a style="color:'.$couleur_texte_btn_close.'" class="btn '.$couleur_btn_close.' '.$taille_btn_close.' popup-modal-dismiss" href="#">'.$texte_close.'</a></div>';
			}
			$text_out .='</div></div></div></div>';
						
			//Récupére le code html de la page affichée
			$buffer = JResponse::getBody();			
	  				  
			//Affichage encadré
			if ($type_affichage == 1) {		

				$script = '<script type="text/javascript">';
				$script .="jQuery(document).on('click', '.popup-modal-dismiss', function () {jQuery('#cadre_alert_cookies').html(''); document.cookie='fmalertcookies=true';});";
				$script .="</script>";
							
				// Position Haut		
				if ($position == 0) {
                    $buffer = preg_replace('/<body(.*?)>/i', '<body$1>'.$text_out.$script, $buffer);
				} 
				// Position Bas
				elseif ($position == 1) {
					$buffer = str_replace('/</body>/i',$text_out.$script.'</body>', $buffer);
				}
			} 
			
			//Affichage Popup
			elseif($type_affichage == 0) {
				
				$params = "";				
				if ($btn_close) {
					$params = "modal: true";													
				} else {
					//Insert un cookie pour éviter de réafficher le message.
					setcookie ( 'fmalertcookies',true);	
				}
				
				$popup = '<script type="text/javascript">';
				$popup .="jQuery.magnificPopup.open({items: {src: '". str_replace("\r\n", "",addslashes($text_out))."',type: 'inline'},$params});";
				$popup .="jQuery(document).on('click', '.popup-modal-dismiss', function (e) {e.preventDefault();jQuery.magnificPopup.close(); document.cookie='fmalertcookies=true';});";
				$popup .="</script>";
				$buffer = str_replace('</body>',$popup.'</body>', $buffer);
			}
			
						
			JResponse::setBody($buffer);					
		}
    }
}

?>